/*
 * @copyright		© Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.externalcontent.gadget.translation
 *
 * @revision		$$
 */

jQuery.plugin( 'de_epages.externalcontent.gadget.translation', {
	plugin:	['jQuery.ui.widget', 'jQuery.uid', 'de_epages.core']
}, function ($) {
	// Constants.
	var gClassNames = '';

	// The actual widget.
	$.widget('de_epages.externalcontent.gadget.Translation', {

		options : {
			service : 'google' // Or 'microsoft'. (You be the judge!)
		},

		_create : function () {
			var self = this,
	 				o = self.options;

			if(o.service === 'google'){
				var googleTranslateUrl = '//translate.google.com/translate_a/element.js',
					googleTranslateScriptSrc = googleTranslateUrl + '?cb=' + 'de_epages.externalcontent.gadget.Translation.googleCallback';
				// Extend the widget prototype class.
				de_epages.externalcontent.gadget.Translation.googleCallback = function () {
					new google.translate.TranslateElement({
						pageLanguage: epConfig.language,
						layout: google.translate.TranslateElement.InlineLayout.SIMPLE
					}, 'google_translate_element');
				};

				self.container = $('<div id="google_translate_element">').appendTo(self.element.addClass(gClassNames));

				if (window.google && window.google.translate) {
					de_epages.externalcontent.gadget.Translation.googleCallback();
				}
				else {
					$('<script type="text/javascript" src="' + googleTranslateScriptSrc + '">').appendTo('body');
				}
			}
			if(o.service === 'microsoft'){
				var microsoftTranslateScriptSrc = ((location && location.href && location.href.indexOf('https') == 0) ? "https://ssl.microsofttranslator.com" : "http://www.microsofttranslator.com" ) + "/ajax/v2/widget.aspx?mode=manual&from=en&layout=ts";

				self.container = $('<div id="MicrosoftTranslatorWidget">').appendTo(self.element.addClass(gClassNames));
				$('<script type="text/javascript" src="' + microsoftTranslateScriptSrc + '">').appendTo('body');
			}
		},

		destroy : function () {
			var self = this;
	 		// Remove all traces of the widget.
	 		self.element.removeClass(gClassNames);
			self.container.remove();
			self.Inherited(arguments);
		}

	});


});