/*
 * @copyright		© Copyright 2006-2011, epages GmbH, All Rights Reserved.
 *
 * @module			ep.ui.colortool
 *
 * @revision		$Revision: 1.1.2.1 $
 */

jQuery.plugin( "ep.ui.colortool", ["ep.ajax", "ep.ui.colorpicker"], function($){

	$.widget( "ep.ui.Colortool", ep.ui.Colorpicker, {

		options: {
			color: ""
		},

		_create: function(){
			var self = this,
				elem = self.element,
				o = self.options;

			elem.attr("readonly",true)
				.val( o.color = o.color || elem.val() || "#fff" );

			//
			if( epages.vars.StyleUserDefinedColors ){
				var extended = {
						baseColors:	$("#LayoutBackgroundColor").val(),
						userColors: {},
						userColorsSave: function( data ){
							var ajaxData = [
									{name: "ViewAction",	value: "JSONViewResponse"},
									{name: "ChangeAction",	value: "SaveGUIDList"},
									{name: "ObjectID",		value: ep.config.siteId}
								];

							$.each( data, function(){
								ajaxData.push(
									{name: "GUID",			value: self.styleId},
									{name: "Name",			value: this.name},
									{name: "Value",			value: this.value}
								);
							});

							ep.ajax({
								type:		"post",
								dataType:	"json",
								data:		ajaxData
							});
						}
					};

				$.each( epages.vars.StyleUserDefinedColors.split("|"), function( i, val ){
					extended.userColors[ "UserDefinedColor"+i ] = val;
				});

				o.extended = extended;
			}

			self.Inherited(arguments);

			elem.addClass("ep-uiColortool")
				.on("colorApply.uiColortool", self.Proxy("_onApply"));
		},

		_init: function(){
			this.Inherited(arguments);
			this._setColorTool( this.options.color );
		},
		
		_setColorTool: function( color ){
			var isTransparent = color == "transparent";

			this.elem
				.css("background-color", isTransparent ? "#fff" : color)
				.toggleClass("ep-uiColortool-transparent",isTransparent)
				.val(color);
		},

		_onApply: function( event, color ){
			this._setColorTool(color);

			$( this.elem.trigger({type:"change",dojoconnect:true})[0].form ).trigger("change");
		},

		destroy: function(){
			this.elem
				.off(".uiColortool");

			this.Inherited(arguments);
		}

	});

});