jQuery.plugin('de_epages.presentation.ui.previeweditor',
{
	plugin : ['jQuery.ckeditor.adapters.jquery', 'jQuery.ui.widget', 'de_epages.core']
}, function ($) {
	// Widget.
	$.widget('de_epages.presentation.ui.Previeweditor', {

		options : {
			name : '', // Name of associated (hidden) textarea.
			config : {} // Options to pass to the *ckeditor*.
		},

		_create : function () {
			var self = this,
					o = self.options;

			// Merge in options from data attribute.
			$.extend(true, o, $.parseJSON(self.element.attr('data-de_epages-presentation-ui-previeweditor')));

			// Set textarea.
			self.textarea = $('textarea[name="' + o.name + '"]').first();

			// Create editor.
			// We have to remove the *toolbar* plugin, because otherwise we run into a bug
			// in the *destroy* event listener of the toolbar plugin, since
			// we never actually display a toolbar.
			self.ckeditor = new CKEDITOR.editor($.extend(o.config, {removePlugins : (o.config.removePlugins  ? (o.config.removePlugins + ',toolbar') : 'toolbar')}),
				new CKEDITOR.dom.element('div'),
				CKEDITOR.ELEMENT_MODE_NONE,
				self.textarea.val()
			);

			// Assign *setData* listener to update *textarea* after editing in *epAlmostFullscreen*.
			self.ckeditor.on('afterSetData', self.Proxy('_afterSetData'));

			// Assign *click* listener to execute *epAlmostFullscreen* plugin.
			self.element.on('click.presentationUiPrevieweditor', self.Proxy('_execEpAlmostFullscreen'));
		},

		_execEpAlmostFullscreen : function (event) {
			this.ckeditor.setData(this.textarea.val());
			this.ckeditor.execCommand('epalmostfullscreen');
		},

		_afterSetData : function (event) {
			var data = event.editor.getData();

			this.textarea.val(data);
			this.element.html(data);
			this.textarea.trigger('change');
		},

		destroy : function () {
			this.ckeditor && this.ckeditor.destroy();
			this.element && this.element.off('click.presentationUiPrevieweditor');
			this.Inherited(arguments);
		}

	});

});